#! /usr/bin/perl -wT

use strict ;

my @strs = (
"http://www.ox.ac.uk/",
"<http://www.ox.ac.uk/>",
"<http://www.ox.ac.uk/>.",
"http://www.ox.ac.uk/query?age>30",
"<http://www.ox.ac.uk/query?age>30>"
) ;

my $arg = $ARGV[0] ;
print "$arg => @{[extractUrl( $arg )]}\n\n" ;

foreach my $str (@strs)
{
#	print $str . " => " . extractUrl( $str ) . "\n\n" ;
}

sub extractUrl
{
	my $str = shift @_ ;
	$str =~ /^(<)?([A-Za-z0-9]+):([^>]*)(>.*)?$/ || return "" ;
	my $prefix = ($1) ? $1 : "" ;
	my $scheme = $2 ;
	my $path = $3 ;
	my $postfix = ($4) ? $4 : "" ;
	print "prefix: $prefix\n" ;
	print "scheme: $scheme\n" ;
	print "path: $path\n" ;
	print "postfix: $postfix\n" ;
	if (($prefix eq "") && ($postfix ne ""))
	{
		$path .= $postfix ;
	}
	return "$scheme:$path" ;
}
